hdu 1011 Starship Troopers 树形dp

8 篇文章 0 订阅

Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 11074    Accepted Submission(s): 3044


Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.
 

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.
 

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.
 

Sample Input
  
  
5 10 50 10 40 10 40 20 65 30 70 30 1 2 1 3 2 4 2 5 1 1 20 7 -1 -1
 

Sample Output
  
  
50 7
 

Author
XU, Chuan
 

Source
 

Recommend
JGShining   |   We have carefully selected several similar problems for you:   1203  2955  2415  1059  1114 
 

一开始没看懂题意,wa了好几遍。。。后来看题解才知道没有兵的话是没法获得价值的。。。

题意:一棵树,有n个结点,每个结点有v个bug,有w的brain。我从1号结点开始走,带着m个战士。
1个战士可以消灭20个bugs,如果我把某个结点的所有bug都消灭了我就能得到那个结点的brain。
如果想攻击当前结点,那么必须先攻击了它的父结点。

思路:背包思想,dp[i][j]表示在i节点有j个士兵的时候的最大价值,但要从1开始,因为0士兵不能获得价值。

最后特判m=0的时候直接输出0

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <queue>
#include <map>
using namespace std;
const int N=105;
const int inf=0x3f3f3f3f;
struct node
{
    int v,next;
}edge[2*N];
int p=1;
int n,m,u,v;
int dp[N][N],head[N],bug[N],val[N];
void addedge(int i,int j)
{
    edge[p].v=j;
    edge[p].next=head[i];
    head[i]=p++;
    edge[p].v=i;
    edge[p].next=head[j];
    head[j]=p++;
}
void init(){
    p=1;
    memset(dp,0,sizeof(dp));
    memset(head,-1,sizeof(head));
    for(int i=1;i<=n;i++){
        scanf("%d%d",&bug[i],&val[i]);
        bug[i]=(bug[i]+19)/20;
    }
    for(int i=1;i<n;i++){
        scanf("%d%d",&u,&v);
        addedge(u,v);
    }
}
void dfs(int u,int pre){
    for(int i=m;i>=bug[u];i--)
        dp[u][i]=val[u];
        
    for(int i=head[u];i!=-1;i=edge[i].next){
        int vt=edge[i].v;
        if(vt==pre)continue;
        dfs(vt,u);
        for(int j=m;j>=bug[u];j--){
            for(int k=1;k<=j-bug[u];k++){
                dp[u][j]=max(dp[u][j],dp[u][j-k]+dp[vt][k]);
            }
        }
    }
}
int main()
{
    while(scanf("%d%d",&n,&m),!(n==-1&&n==-1)){
        init();
        if(m==0){printf("0\n");continue;}
        dfs(1,0);
        printf("%d\n",dp[1][m]);
    }
    return 0;
}



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值